/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 30, 2004, 5:07:38 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.formulae;

import junit.framework.TestCase;

/**
 * Test if ProblemID(String) ok for CalcHead.uses*
 * 
 * @author Walther Neuper Sep 30, 2004, 5:07:38 PM
 * @version 1.0
 **/
public class TestCalcHeadCompoundID extends TestCase {

	public void testParseProblemID() {
		System.out.println("---BEGIN isac.util.formulae.TestCalcHeadCompoundID");		
		ProblemID p1, p2;
		
		p1 = new ProblemID();
		p1.addString("rational");
		p1.addString("univariate");
		p1.addString("equation");	
		p2 = new ProblemID("[rational,univariate,equation]");
		assertEquals("easy construction", p1, p2);
		
		//here are some blanks v         v          v v        v
		p2 = new ProblemID("  [ rational, univariate , equation ]");
		assertEquals("tricky construction", p1, p2);

		p1 = new ProblemID();
		p2 = new ProblemID("[]");		
		assertEquals("empty construction", p1, p2);		
		
	}
	
	public void testBelongsToClass() {
		ProblemID p1, p2, p3;
		
		p1 = new ProblemID("[rational,univariate,equation]");
		p2 = new ProblemID("[univariate,equation]");
		p3 = new ProblemID("[]");
		assertTrue("equals implies belongsToClass",p1.belongsToClass(p1));
		assertTrue("belongsToClass",p1.belongsToClass(p2));
		assertTrue("ProblemID('[]') is universal",p1.belongsToClass(p3));
		assertFalse("equals implies belongsToClass",p2.belongsToClass(p1));
		System.out.println("---END isac.util.formulae.TestCalcHeadCompoundID");		
	}	
}
