/*
 * Created on Oct 7, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package isac.browserdialog;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Vector;

/*
 * @author Andreas Griesmayer
 *
 * Remote interface for methods of the BrowserDialog which are to be called over RMI
 */
public interface BDialog extends Remote{
	/**
	 *  This method loads binary-files from the KEStore
	 * @param type Type of KE-Object to load
	 * @param filename id of the binaryfile to load
	 * @return binary-file as byte array or empty bytearray if file was not found
	 */
	public abstract byte[] loadBinary(String type, String filename) throws RemoteException;
//	public abstract Vector loadBinary(String session, String type, String filename) throws RemoteException;
/**
 * Loads the hierarchy of the type <code>type</code> from the KE-Store
 * 
 * @param type requestet information-type to load the hierarchy for. e.g. "pbl", "met", or "exp"
 * @return the hierarchy in its XML-representation. The result might be filtered according to the current session the 
 * BrowserDialog was instantiated for
 */
	public abstract String loadHierarchy(String type) throws RemoteException;
//	public abstract Vector loadHierarchy(String session, String type) throws RemoteException;
	//public Vector loadMETHierarchy(String session, String type){
	
//	public abstract Vector loadContent(String session, String type, String filename) throws RemoteException;
	/**
	 * Loads the requested KE-Object of the type <code>type</code> from the KE-Store
	 * <code>type</code> and <code>content_id</code> together give the unique id. One and the
	 * same <code>content_id</code> might be used in different types (<code>type</code> can be "pbl", or "met" for the 
	 * basic items of the knowledge-base as well as an identifyer used for different courses). If objects with equal <code>content_id</code>s
	 * reside in different types, their only difference should reside within the description.
	 * 
	 * @param type requestet information-type to load the content for. e.g. "pbl", "met", or "exp"
	 * @param content_id identifies the KE-Object within the <code>type</code> 
	 * @return requested KE-Object in its XML-representation. The result might be filtered according to the current session the 
	 * BrowserDialog was instantiated for
	 */
	public abstract String loadContent(String type, String content_id) throws RemoteException;
	public abstract String loadContent(String type, Vector id_vect) throws RemoteException;
	
	/**
	 * Loads the requested KE-Object of the type <code>type</code> from the KE-Store and evaluates it using the 
	 * WorksheetDialog identified by <code>wd_id</code>.
	 * <code>type</code> and <code>content_id</code> together give the unique id. One and the
	 * same <code>content_id</code> might be used in different types (<code>type</code> can be "pbl", or "met" for the 
	 * basic items of the knowledge-base as well as an identifyer used for different courses). If objects with equal <code>content_id</code>s
	 * reside in different types, their only difference should reside within the description.
	 * 
	 * @param type requestet information-type to load the content for. e.g. "pbl", "met", or "exp"
	 * @param content_id identifies the KE-Object within the <code>type</code>
	 * @param wd_id identifies the WorksheetDialog to connect for evaluation
	 * @return requested KE-Object in its XML-representation. The result might be filtered according to the current session the 
	 * BrowserDialog was instantiated for
	 */
	public abstract String evaluateContent(String type, String content_id, String wd_id) throws RemoteException;
}