/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui.util;

import isac.util.*;
import isac.util.formulae.*;

/**
 * Dummy class to test the formalization geneartion. This class is also
 * needed to start a calculation.
 * 
 * @author Mario Hochreiter
 * @version
 *
 */
public class DummyFormalizationGenerator {
  // Set up a calcHead to solve a sample linear equation 
  // (Data from sml/systest/FE-Interfaces.sml)
  public static Formalization setUpSolveLinear() {
    CalcHeadItemList itemList;
    CalcHeadItem item;
    Formalization f = new Formalization();
    Variant v = new Variant();
    v.addNewIsaString("equality (1+-1*2+x=0)");
    v.addNewIsaString("solveFor x");
    v.addNewIsaString("solutions L");

    CalcHeadSimpleID id;
    id = new CalcHeadSimpleID();
    id.setID("Test.thy");

    Specification s = new Specification();
    s.setTheory(id);

    CalcHeadCompoundID idl;

    idl = new CalcHeadCompoundID();
    idl.addString("linear");
    idl.addString("univariate");
    idl.addString("equation");
    idl.addString("test");
    s.setProblem(idl);
    idl = new CalcHeadCompoundID();
    idl.addString("Test");
    idl.addString("solve_linear");

    s.setMethod(idl);
    v.setSpecification(s);
    f.addNewVariant(v);
    return f;
  }

  //Set up a calcHead to solve a sample problem with a mini-SubProblem
  // (Data from sml/systest/FE-Interfaces.sml)
  public static Formalization setUpSolveMiniSubProb() {
    CalcHeadItemList itemList;
    CalcHeadItem item;
    Formalization f = new Formalization();
    Variant v = new Variant();
    v.addNewIsaString("equality (x+1=2)");
    v.addNewIsaString("solveFor x");
    v.addNewIsaString("solutions L");

    CalcHeadSimpleID id;
    id = new CalcHeadSimpleID();
    id.setID("Test.thy");

    Specification s = new Specification();
    s.setTheory(id);

    CalcHeadCompoundID idl;

    idl = new CalcHeadCompoundID();

    idl.addString("sqroot-test");
    idl.addString("univariate");
    idl.addString("equation");
    idl.addString("test");
    s.setProblem(idl);

    idl = new CalcHeadCompoundID();
    idl.addString("Test");
    idl.addString("squ-equ-test-subpbl1");

    s.setMethod(idl);
    v.setSpecification(s);
    f.addNewVariant(v);
    return f;
  }
}
