/****************************************************************** 
* @author Alois Kirchsteiger member of the isac team
* Copyright (c) 2004 by Alois Kirchsteiger
* create 21.09.2004, 10:43:41
* Insitute for Softwaretechnology, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

//TODO: implement!!!

package isac.session;

import java.io.Serializable;
import java.util.Date;

/**
 * SuccessInfo stores the Information about how successful
 * a user was with a specific CalcElement
 * the SuccessInfo is stored in the <code>UserModel</code>
 * which exists for each <code>User</code> once.
 * 
 * @author Alois Kirchsteiger 21.09.2004 10:43:41
 */
public class SuccessInfo implements Serializable {
  
  private int nrOfTries;

  private int nrOfSuccess;
  
  private int nrOfSuccessesAfterLastFailure;
  
  /*
   * as the can be different levels of failure, for each try
   * there will be inserted a number between 0(total failure)
   * and 1(success).
   * the successIndicator stores the average number for all tries,
   * and so its value can also only be betwenn 0 and 1
   */
  private float successIndicator;

  private Date lastTry;
  
  public SuccessInfo(float success) {
    nrOfTries = 1; 
    //if successful
    if (success == 1) {
      nrOfSuccess = 1;
      nrOfSuccessesAfterLastFailure = 1;
    } else {
      nrOfSuccess = 0;
      nrOfSuccessesAfterLastFailure = 0;
    }  
    successIndicator = success;
    lastTry = new Date(java.lang.System.currentTimeMillis());
  }
  
  public void addSuccess(float success) {
    nrOfTries++;
    //if successful
    if (success == 1) {
      nrOfSuccess++;
      nrOfSuccessesAfterLastFailure++;
    } else {
      nrOfSuccessesAfterLastFailure = 0;
    }
    successIndicator = (successIndicator * (nrOfTries-1) + success) /
                       nrOfTries;
    lastTry = new Date(java.lang.System.currentTimeMillis());
  }
  
  public int getNrOfTries() {
    return nrOfTries;
  }
  
  public int getNrOfSuccess() {
    return nrOfSuccess;
  }
  
  public int getNrOfSuccessesAfterLastFailure() {
    return nrOfSuccessesAfterLastFailure;
  }
  
  /**
   * as the can be different levels of failure, for each try
   * there will be inserted a number between 0(total failure)
   * and 1(success).
   * the successIndicator stores the average number for all tries,
   * and so its value can also only be betwenn 0 and 1
   */
  public float getSuccessIndicator() {
    return successIndicator;
  }
  
  public Date getLastTry() {
    return lastTry;
  }
}
