/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Nov 4, 2004, 6:15:04 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util;

import java.io.Serializable;

import isac.util.formulae.Position;

/**
 * Contains the 3 iterators which describe the changes in a CalcTree caused by
 * one step (a Tactic or an input Formula). Needed for reference by
 * 
 * @see isac.util.parser.XMLParserDigest
 * 
 * @author Walther Neuper Nov 4, 2004, 6:15:04 PM
 * @version 1.0
 */
public class CalcChanged implements Serializable {
	// trial for Digest: ^^^^^^^^^^^^^^^^^^^^^^^ WN041105

	/**
	 * @see isac.util.CalcChangedEvent#getLastUnchangedFormula()
	 */
	Position last_unchanged_formula_;

	/**
	 * @see isac.util.CalcChangedEvent#getLastDeletedFormula()
	 */
	Position last_deleted_formula_;

	/**
	 * @see isac.util.CalcChangedEvent#getLastGeneratedFormula()
	 */
	Position last_generated_formula_;

	public void setLastUnchanged(Position last_unchanged_formula) {
		last_unchanged_formula_ = last_unchanged_formula;
	}

	public void setLastDeleted(Position last_deleted_formula) {
		last_deleted_formula_ = last_deleted_formula;
	}

	public void setLastGenerated(Position last_generated_formula) {
		last_generated_formula_ = last_generated_formula;
	}

	public Position getLastUnchanged() {
		return last_unchanged_formula_;
	}
	public Position getLastDeleted() {
		return last_deleted_formula_;
	}
	public Position getLastGenerated() {
		return last_generated_formula_;
	}
	
	
	
}