/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 20, 2004, 4:18:31 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.formulae;

import java.util.Vector;

import isac.util.interfaces.ICalcElement;

/**
 * The assumptions generated by application of the tactic to the formula, both
 * under the same CalcIterator.
 * 
 * *ATTENTION*: still also used for
 * {isac.interfaces.ICalcIterator#fetchApplicalbeTactics} as long as this does
 * _not_ return references to _several_ Formula holding Assumptions
 * 
 * @author Walther Neuper Sep 20, 2004, 4:18:31 PM
 * @version 1.0
 */
public class Assumptions implements ICalcElement {

	Vector formulae_;

	public Assumptions() {
		super();
		formulae_ = new Vector();
	}

	/**
	 * @see isac.util.interfaces.ICalcElement#toSMLString()
	 * ATTENTION: does NOT make sense for the Vector formulae_
	 */
	public String toSMLString() {
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#getMathML()
	 */
	public String getMathML() {
		// TODO Auto-generated method stub
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#getType()
	 */
	public int getType() {
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#getVisibility()
	 */
	public int getVisibility() {
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#setVisibility(int)
	 */
	public void setVisibility(int visibility) {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#getViewStyle()
	 */
	public int getViewStyle() {
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#setViewStyle(int)
	 */
	public void setViewStyle(int view_style) {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#getRating()
	 */
	public int getRating() {
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see isac.util.interfaces.ICalcElement#setRating(int)
	 */
	public void setRating(int rating) {
		// TODO Auto-generated method stub

	}

	//also used in XMLParser @see {isac.util.parser.XMLParserDigest}
	public void setFormula(Formula asm) {
		formulae_.add(asm);
	}

	public Vector getFormulae() {
		return formulae_;
	}

}