/*
 * Created on Feb 6, 2004
 */
package isac.wsdialog;

import isac.util.interfaces.ICalcElement;


/**
 * Describes a user action which has to pass a CalcElement,
 * e.g a newly entered formula or tactic which is not yet
 * part of the calculation tree.
 * @see isac.wsdialog.UserActionOnIterator
 * @see isac.wsdialog.UserActionOnCalcHeadCompoundID
 * @author Alan Krempler
 */
public class UserActionOnCalcElement extends UserAction {
	private ICalcElement calc_element_;
	
	public UserActionOnCalcElement(int id, ICalcElement calc_element) {
		super(id);
		calc_element_ = calc_element; 
	}
	
	public ICalcElement getCalcElement() {
		return calc_element_;
	}

}
