(* use"ME/ctreeNEW.sml";
   use"ctreeNEW.sml";
   *)



(*drop first element and make run on []*)
fun get_tlpos' p pt =
    let val ps = get_allpos' p pt
    in if null ps then ps else tl ps end;
fun get_tlpos's p pts =
    let val ps = get_allpos's p pts
    in if null ps then ps else tl ps end;

(*---OLD---*)
fun get_allp (cuts: pos' list) (P:pos) pt ((p, p_): pos') =
    (let val nxt = move_dn P pt (drop (length P, p), p_) 
     (*exn if Incomplete reached*)
     in if nxt <> ([],Res) 
	then get_allp (cuts @ [nxt]) P pt nxt
	else (cuts @ [nxt]): pos' list
     end) handle PTREE _ => cuts;
(*.get all positions in a ptree until ([],Res) or ostate=Incomplete
val get_allp = fn : 
  pos' list -> : accumulated, start with []
  pos ->       : the offset for subtrees wrt the root
  ptree ->     : (sub)tree
  pos'         : before the positions in ...
  -> pos' list : of positions in this (sub) tree (relative to the root)
.*)
print_depth 11;
(* val (cuts, P, pt, pos) = ([], [3], get_nd pt [3], ([]:int list,Frm));
   *)
(*----OLD-----*)
fun get_allp (cuts: pos' list) (P:pos) pt (pos:pos') =
    (let val nxt = move_dn P pt pos
     (*exn if Incomplete reached*)
     in if nxt <> ([],Res) 
	then get_allp (cuts @ [nxt]) P pt nxt
	else (cuts @ [nxt]): pos' list
     end) handle PTREE _ => cuts;
print_depth 3;
print_depth 11;
(* val (cuts, P, pt, pos) = ([], [3], get_nd pt [3], ([], Frm):pos');
   val (cuts, P, pt, pos) = ([], [2], get_nd pt [2], ([], Frm):pos');
   length (children pt);
   *)
fun get_allp (cuts:pos' list) (P:pos) pt (pos:pos') =
    (let val nxt = move_dn [] pt pos (*exn if Incomplete reached*)
     in if nxt <> ([],Res) 
	then get_allp (cuts @ [nxt]) P pt nxt
	else (map (apfst (curry op@ P)) (cuts @ [nxt])): pos' list
     end) handle PTREE _ => (map (apfst (curry op@ P)) cuts);
print_depth 3;



(*----OLD-----*)
print_depth 11;
(*the pts are assumed to be on the same level*)
fun get_allps (cuts: pos' list) (P:pos) (pt::pts) =
    let val cuts' = get_allp [] P pt ([], Frm)
	val nxt = last_elem cuts'
    in if nxt <> ([],Res)
       then get_allps (cuts @ cuts') P pts
       else cuts @ cuts'
    end;
print_depth 3;
(* use"ME/ctreeNEW.sml";
   use"ctreeNEW.sml";
   *)
print_depth 11;
(* val (cuts: pos' list, P, pt::pts) = ([], [1], children pt);
   val cuts' = get_allp [] P pt ([], Frm);
   val (cuts: pos' list, P, pt::pts) = (cuts @ cuts', lev_on P, pts);
   val cuts' = get_allp [] P pt ([], Frm);
   length (children pt);
   *)
(*the pts are assumed to be on the same level*)
fun get_allps (cuts: pos' list) (P:pos) (pt::pts) =
    let val cuts' = get_allp [] P pt ([], Frm)
    in get_allps (cuts @ cuts') (lev_on P) pts end;
print_depth 3;


fun del_res (PblObj {cell, fmz, origin, spec, probl, meth, 
		     env, loc=(l1,_), branch, result, ostate}) =
    PblObj {cell=cell,fmz=fmz,origin=origin,spec=spec,probl=probl,meth=meth,
	    env=env, loc=(l1,None), branch=branch, result=(e_term,[]), 
	    ostate=Incomplete}

  | del_res (PrfObj {cell, form, tac, loc=(l1,_), branch, result, ostate}) =
    PrfObj {cell=cell,form=form,tac=tac, loc=(l1,None), branch=branch, 
	    result=(e_term,[]), ostate=Incomplete};


print_depth 11; move_dn; print_depth 3;
print_depth 11; get_allpos'; print_depth 3;


(* for cut_level;  appl_branch(deprecated) *)
(*WN050221: applied wrt a single Nd, _not_ for a level of children*)
fun test_trans (PrfObj{branch = Transitive,...}) = true
  | test_trans (PrfObj{branch = NoBranch,...}) = true
  (*| test_trans (PblObj{branch = NoBranch,...}) = true 
                                       WN050221 for test on worksheet*)
  | test_trans _ = false;
    
(*WN050220: new design S(603)..(608)
p_ is not required !!!*)

(* val (cuts, P, pt as Nd (b,bs), (p::[])) = ([], [], pt, pos);
   val (cuts, P, pt as Nd (b,bs), (p::[])) = ([], [], pt, [2]);
   *)
fun cut_tre cuts P (Nd (b, bs)) (p::[]) =
    let (*top down divide each level into 3 parts...*)
	val keep = take (p - 1, bs)
	val Nd (b',bs') = nth p bs(*here* will be 'insert'ed by 'append_..'*)
	val tail = takerest (p, bs)
    in if test_trans b'
       then (Nd (del_res b(*...and handle parent*), keep(*here at end*)), 
	     cuts
	     @ (get_allpos's (P @ [p], 1) bs') 
	     @ (get_allpos's (P, p + 1) tail)
	     @ (if g_ostate b = Incomplete then [(P,Res)] else []))

       else (Nd (b, keep @ [(*Nd (b',bs') 'insert'ed*)] @ tail), 
	     cuts
	     @ (get_allpos's (P @ [p], 1) bs'))
    end
  | cut_tre cuts P (pt as Nd (b,bs)) (p::ps) = (pt,[])
;
(*
    let (*top down divide each level into 3 parts...*)
	val keep = take (p - 1, bs)
	val (pt' as (Nd (b',_)), cuts') = cut_tre cuts (P@[p]) (nth p bs) ps
	val tail = takerest (p, bs)
    in if test_trans b'
       then (Nd ((*if P=[]...del_res*)b, 
		 keep @ [delete_result pt' []]), 
	     cuts @ cuts' @ ([(*Res pt'?*)]) @ (get_allpos's tail))
       else (Nd (b, keep @ [pt'] @ tail), 
	     cuts @ cuts' @ ([(*Res pt'*)]))
    end
*)
fun cut_tree pt (p,_) = cut_tre [] [] pt pos;
