(* use"calculate.sml";
   use"Isa02/rewrite-parse.sml";
   use"../Isa02/rewrite-parse.sml";
   WN.6.1.00

   both, the rewriter and the parser based on isabelle
   in one file
*)

(*val trace_order = ref false;   25.5.02 loeschen !!!*)

(*.trace internal steps of isac's rewriter*)
val trace_rewrite = ref false;
(*.depth of recursion in traces of the rewriter, if trace_rewrite:=true.*)
val depth = ref 99999;



(* dirty type-conversion 30.1.00 for "fixed_values [R=R]" *)

val aT = Type ("'a", []);
(* isas types for Free, parseold: (1) "R=R" or (2) "R=(R::real)": 
(1)
> val (TFree(ss2,TT2)) = T2;
val ss2 = "'a" : string
val TT2 = ["term"] : sort
(2)
> val (Type(ss2',TT2')) = T2';
val ss2' = "RealDef.real" : string
val TT2' = [] : typ list
(3)
val realType = TFree ("RealDef.real", HOLogic.termS);
is different internally, too;

(1) .. (3) are displayed equally !!!
*)



(* 30.1.00: generating special terms for ME:
   (1) binary numerals reconverted to Free ("#num",...) 
       by libarary_G.num_str: called from parse (below) and 
       interface_ME_ISA for all thms used
       (compare HOLogic.dest_binum)
   (2) 'a types converted to RealDef.real by typ_a2real
       in parse below
   (3) binary operators fixed to type real in RatArith.thy
       (trick by Markus Wenzel)
*)




(** calculate numerals **)

(*27.3.00: problems with patterns below:
"Vars (a // #2 = r * xxxxx b)" doesn't work, but 
"Vars (a // #2 = r * sqrt b)" works
*)


(* scan a term for applying eval_fn ef 
args
  thy:
  op_: operator (as string) selecting the root of the pair
  ef : fn : (string -> term -> theory -> (string * term) option)
             ^^^^^^... for creating the string for the resulting theorem
  t  : term to be scanned
result:
  (string * term) option: found by the eval_* -function of type
       fn : string -> string -> term -> theory -> (string * term) option
            ^^^^^^... the selecting operator op_ (variable for eval_binop)
*)
fun get_pair thy op_ (ef:string -> term -> theory -> (string * term) option) 
    (t as (Const(op0,t0) $ arg)) =                      (* unary fns *)
    if op_ = (*strip_thy*) op0 then 
	let val popt = ef op_ t thy
	in case popt of
	       Some _ => popt
	     | None => get_pair thy op_ ef arg end
    else get_pair thy op_ ef arg
 
  | get_pair thy "Atools.ident" ef (t as (Const("Atools.ident",t0) $ _ $ _ )) =
    ef "Atools.ident" t thy                                 (* not nested *)
(* val (thy,op_,ef,t as (Const(op0,_)$t1$t2)) =
       (thy,op_,eval_fn,ct);
   *)
  | get_pair thy op_ ef (t as (Const(op0,_) $ t1 $ t2)) =  (* binary funs*)
    ((*writeln("@@@ get_pair: binop, t = "^
	     (Sign.string_of_term (sign_of thy) t));*)
     if op_ = op0 then 
	 let (*val _=writeln"@@@ get_pair: then 1"*)
	     val popt = ef op_ t thy;
	 in case popt of 
		Some (id,_) => ((*writeln("@@@ get_pair: t -> Some "^id);*)
				popt)
	      | None => 
		let (*val _= writeln"@@@ get_pair: t -> None"*)
		    val popt = get_pair thy op_ ef t1
		in case popt of 
		       Some (id,_) => 
		       ((*writeln("@@@ get_pair: t1 -> Some "^id);*)
			popt)
		     | None => ((*writeln"@@@ get_pair: t1 -> None";*)
				get_pair thy op_ ef t2) 
		end
	 end
     else (*search subterms*)
	 let (*val _= writeln"@@@ get_pair: t else"*)
	     val popt = get_pair thy op_ ef t1
	 in case popt of 
		Some (id,_) => ((*writeln("@@@ get_pair: t1 -> Some "^id);*)
				popt)
	      | None => ((*writeln"@@@ get_pair: t1 else -> None";*)
			 get_pair thy op_ ef t2) 
	 end)

  | get_pair thy op_ ef (Const _) = None
  | get_pair thy op_ ef (Free _) = None
  | get_pair thy op_ ef (Var _) = None
  | get_pair thy op_ ef (Bound _) = None
  | get_pair thy op_ ef (Abs(a,T,body)) = get_pair thy op_ ef body
  | get_pair thy op_ ef (t1$t2) = 
    let (*val _= writeln"### get_pair: t1 $ t2"*)
	val popt = get_pair thy op_ ef t1
    in case popt of 
	   Some _ => popt
	 | None => ((*writeln"### get_pair: t1 $ t2 -> None";*)
		    get_pair thy op_ ef t2) 
    end;
 (*
>  val t = (term_of o the o (parse thy)) "#3 + #4";
>  val eval_fn = the (assoc (!eval_list, "op +"));
>  val (Some (id,t')) = get_pair thy "op +" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
>  atomty thy t';
> 
>  val t = (term_of o the o (parse thy)) "(a + #3) + #4";
>  val (Some (id,t')) = get_pair thy "op +" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "#3 + (#4 + (a::real))";
>  val (Some (id,t')) = get_pair thy "op +" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "x = #5 * (#3 + (#4 + a))";
>  atomty thy t;
>  val (Some (id,t')) = get_pair thy "op +" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
>  val it = "#3 + (#4 + a) = #7 + a" : string
>
>
>  val t = (term_of o the o (parse thy)) "#-4//#-2";
>  val eval_fn = the (assoc (!eval_list, "cancel"));
>  val (Some (id,t')) = get_pair thy "cancel" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "#2^^^#3";
>  eval_binop "xxx" "pow" t thy;
>  val eval_fn = (eval_binop "xxx")
>		 : string -> term -> theory -> (string * term) option;
>  val Some (id,t') = get_pair thy "pow" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
>  val eval_fn = the (assoc (!eval_list, "pow"));
>  val (Some (id,t')) = get_pair thy "pow" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "x = #0 + #-1 * #-4";
>  val eval_fn = the (assoc (!eval_list, "op *"));
>  val (Some (id,t')) = get_pair thy "op *" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "#0 < #4";
>  val eval_fn = the (assoc (!eval_list, "op <"));
>  val (Some (id,t')) = get_pair thy "op <" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
>  val t = (term_of o the o (parse thy)) "#0 < #-4";
>  val (Some (id,t')) = get_pair thy "op <" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "#3 is_const";
>  val eval_fn = the (assoc (!eval_list, "is'_const"));
>  val (Some (id,t')) = get_pair thy "is'_const" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
>  val t = (term_of o the o (parse thy)) "a is_const";
>  val (Some (id,t')) = get_pair thy "is'_const" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "#6//(#8::real)";
>  val eval_fn = the (assoc (!eval_list, "cancel"));
>  val (Some (id,t')) = get_pair thy "cancel" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
> 
>  val t = (term_of o the o (parse thy)) "sqrt #12";
>  val eval_fn = the (assoc (!eval_list, "SqRoot.sqrt"));
>  val (Some (id,t')) = get_pair thy "SqRoot.sqrt" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
>  val it = "sqrt #12 = #2 * sqrt #3 " : string
>
>  val t = (term_of o the o (parse thy)) "sqrt #9";
>  val (Some (id,t')) = get_pair thy "SqRoot.sqrt" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
>
>  val t = (term_of o the o (parse thy)) "Nth #2 [#11,#22,#33]";
>  val eval_fn = the (assoc (!eval_list, "Tools.Nth"));
>  val (Some (id,t')) = get_pair thy "Tools.Nth" eval_fn t;
>  Sign.string_of_term (sign_of thy) t';
*)

(* val ((op_, eval_fn),ct)=(cc,pre);
   (get_calculation_ Isac.thy (op_, eval_fn) ct) handle e => print_exn e;
   parse thy ""
   *)
(*.apply ONLY to (app_num_tr'2 term), app_num_tr'2 (- 4711) --> (-4711).*)
fun get_calculation_ thy (op_, eval_fn) ct =
  case get_pair thy op_ eval_fn ct of
	 None => ((*writeln("@@@ get_calculation: None, op_="^op_);
		  writeln("@@@ get_calculation: ct= ");atomty thy ct;*)
		  None)
       | Some (thmid,t) =>
	   ((*writeln("@@@ get_calculation: None, op_="^op_);
	    writeln("@@@ get_calculation: ct= ");atomty thy ct;*)
	    Some (thmid, (make_thm o (cterm_of (sign_of thy))) t));
(*
> val ct = (the o (parse thy)) "#9 is_const";
> get_calculation_ thy ("is'_const",the (assoc(!eval_list,"is'_const"))) ct;
val it = Some ("is_const9_","(is_const 9 ) = True  [(is_const 9 ) = True]")

> val ct = (the o (parse thy)) "sqrt #9";
> get_calculation_ thy ("sqrt",the (assoc(!eval_list,"sqrt"))) ct;
val it = Some ("sqrt_9_","sqrt 9  = 3  [sqrt 9  = 3]") : (string * thm) option

> val ct = (the o (parse thy)) "#4<#4";
> get_calculation_ thy ("op <",the (assoc(!eval_list,"op <"))) ct;fun is_no str = (hd o explode) str = "#";

val it = Some ("less_5_4","(5 < 4) = False  [(5 < 4) = False]")

> val ct = (the o (parse thy)) "a<#4";
> get_calculation_ thy ("op <",the (assoc(!eval_list,"op <"))) ct;
val it = None : (string * thm) option

> val ct = (the o (parse thy)) "#5<=#4";
> get_calculation_ thy ("op <=",the (assoc(!eval_list,"op <="))) ct;
val it = Some ("less_equal_5_4","(5 <= 4) = False  [(5 <= 4) = False]")

-------------------------------------------------------------------6.8.02:
 val thy = SqRoot.thy;
 val t = (term_of o the o (parse thy)) "1+2";
 get_calculation_ thy (the(assoc(!calc_list,"plus"))) t;
 val it = Some ("add_3_4","3 + 4 = 7  [3 + 4 = 7]") : (string * thm) option
-------------------------------------------------------------------6.8.02:
 val t = (term_of o the o (parse thy)) "-1";
 atomty Isac.thy t;
 val t = (term_of o the o (parse thy)) "0";
 atomty Isac.thy t;
 val t = (term_of o the o (parse thy)) "1";
 atomty Isac.thy t;
 val t = (term_of o the o (parse thy)) "2";
 atomty Isac.thy t;
 val t = (term_of o the o (parse thy)) "999999999";
 atomty Isac.thy t;
-------------------------------------------------------------------6.8.02:

> val ct = (the o (parse thy)) "a+#3+#4";
> get_calculation_ thy ("op +",the (assoc(!eval_list,"op +"))) ct;
val it = Some ("add_3_4","a + 3 + 4 = a + 7  [a + 3 + 4 = a + 7]")
 
> val ct = (the o (parse thy)) "#3+(#4+a)";
> get_calculation_ thy ("op +",the (assoc(!eval_list,"op +"))) ct;
val it = Some ("add_3_4","3 + (4 + a) = 7 + a  [3 + (4 + a) = 7 + a]")
 
> val ct = (the o (parse thy)) "a+(#3+#4)+#5";
> get_calculation_ thy ("op +",the (assoc(!eval_list,"op +"))) ct;
val it = Some ("add_3_4","3 + 4 = 7  [3 + 4 = 7]") : (string * thm) option

> val ct = (the o (parse thy)) "#3*(#4*a)";
> get_calculation_ thy ("op *",the (assoc(!eval_list,"op *"))) ct;
val it = Some ("mult_3_4","3 * (4 * a) = 12 * a  [3 * (4 * a) = 12 * a]")

> val ct = (the o (parse thy)) "#3 + #4^^^#2 + #5";
> get_calculation_ thy ("pow",the (assoc(!eval_list,"pow"))) ct;
val it = Some ("4_(+2)","4 ^ 2 = 16  [4 ^ 2 = 16]") : (string * thm) option

> val ct = (the o (parse thy)) "#-4//#-2";
> get_calculation_ thy ("cancel",the (assoc(!eval_list,"cancel"))) ct;
val it = Some ("cancel_(-4)_(-2)","(-4) // (-2) = (+2)  [(-4) // (-2) = (+2)]")

> val ct = (the o (parse thy)) "#6//#-8";
> get_calculation_ thy ("cancel",the (assoc(!eval_list,"cancel"))) ct;
val it = Some ("cancel_6_(-8)","6 // (-8) = (-3) // 4  [6 // (-8) = (-3) // 4]")

*) 


(*
> val ct = (the o (parse thy)) "a + 3*4";
> applicable "calculate" (Calc("op *", "mult_")) ct;
val it = Some "3 * 4 = 12  [3 * 4 = 12]" : thm option

--------------------------
> val ct = (the o (parse thy)) "3 =!= 3";
> val (thmid, thm) = the (get_calculation_ thy "Atools.ident" ct);
val thm = "(3 =!= 3) = True  [(3 =!= 3) = True]" : thm

> val ct = (the o (parse thy)) "~ (3 =!= 3)";
> val (thmid, thm) = the (get_calculation_ thy "Atools.ident" ct);
val thm = "(3 =!= 3) = True  [(3 =!= 3) = True]" : thm

> val ct = (the o (parse thy)) "3 =!= 4";
> val (thmid, thm) = the (get_calculation_ thy "Atools.ident" ct);
val thm = "(3 =!= 4) = False  [(3 =!= 4) = False]" : thm

> val ct = (the o (parse thy)) "( 4 + (4 * x + x ^ 2) =!= (+0))";
> val (thmid, thm) = the (get_calculation_ thy "Atools.ident" ct);
  "(4 + (4 * x + x ^ 2) =!= (+0)) = False"

> val ct = (the o (parse thy)) "~ ( 4 + (4 * x + x ^ 2) =!= (+0))";
> val (thmid, thm) = the (get_calculation_ thy "Atools.ident" ct);
  "(4 + (4 * x + x ^ 2) =!= (+0)) = False"

> val ct = (the o (parse thy)) "~ ( 4 + (4 * x + x ^ 2) =!= (+0))";
> val rls = eval_rls;
> val (ct,_) = the (rewrite_set_ thy false rls ct);
val ct = "True" : cterm
--------------------------
*)


(*.substitute bdv in an rls and leave Calc as they are.(*28.10.02*)
fun inst_thm' subs (Thm (id, thm)) = 
    Thm (id, (*read_instantiate throws: *** No such variable in term: ?bdv*)
	 (read_instantiate subs thm) handle _ => thm)
  | inst_thm' _ calc = calc; 
fun inst_thm' (subs as (bdv,_)::_) (Thm (id, thm)) = 
    Thm (id, (writeln("@@@ inst_thm': thm= "^(string_of_thm thm));
	      if bdv mem (vars_str o #prop o rep_thm) thm
	     then (writeln("@@@ inst_thm': read_instantiate, thm="^((string_of_thm thm)));
		   read_instantiate subs thm)
	     else (writeln("@@@ inst_thm': not mem.. "^bdv);
		   thm)))
  | inst_thm' _ calc = calc; 

fun instantiate_rls subs 
  (Rls{preconds=preconds,rew_ord=rew_ord,erls=ev,srls=sr,calc=ca,
       asm_thm=at,rules=rules,scr=scr}:rls) =
  (Rls{preconds=preconds,rew_ord=rew_ord,erls=ev,srls=sr,calc=ca,
       asm_thm=at,scr=scr,
   rules = map (inst_thm' subs) rules}:rls);---------------------------*)



(** rewriting: ordered, conditional **)

fun mk_rule (prems,l,r) = 
    Trueprop $ (list_implies (prems, mk_equality (l,r)));

(* 'norms' a rule, e.g.
(*1*) a = 1 ==> a*(b+c) = b+c 
                =>  a = 1 ==> a*(b+c) = b+c          no change
(*2*) t = t     =>  (t=t) = True                        !!
(*3*) [| k < l; m + l = k + n |] ==> m < n
	        =>  [| k<l; m+l=k+n |] ==> m < n = True !! *)
(* val it = fn : term -> term *)
fun norm rule =
  let
    val (prems,concl)=(map strip_trueprop(Logic.strip_imp_prems rule),
		       (strip_trueprop o  Logic.strip_imp_concl)rule)
  in if is_equality concl then 
      let val (l,r) = dest_equals' concl
      in if l = r then 
	 (*2*) mk_rule(prems,concl,true_as_term)
	 else (*1*) rule end
     else (*3*) mk_rule(prems,concl,true_as_term)
  end;








